#include <windows.h>
#include <tchar.h>
#include "32dib32.h"

#pragma comment(lib, "32dib32.lib")

#define MYWNDCLASS	TEXT("CLASS_32DIB32Test")
#define MYWNDTITLE	TEXT("32DIB32Test")

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

int WINAPI _tWinMain(HINSTANCE hInst,HINSTANCE hInstPrev,LPTSTR lpCmdLine,int nCmdShow)
{
	MSG 	   msg;
	WNDCLASSEX wc;
	HWND	   hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)ProcWnd;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= MYWNDCLASS;
	RegisterClassEx(&wc);
	
	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPEDWINDOW | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				NULL,
				NULL,
				hInst,
				NULL);
	
	while (GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

LRESULT CALLBACK ProcWnd(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static HBITMAP hBmp1,hBmp2,hBmp3;
	
	switch (uMsg)
	{
	case WM_CREATE:
		hBmp1 = b32New(300, 100);
		hBmp2 = b32Load(TEXT("back.bmp"));
		hBmp3 = b32Load(TEXT("star.bmp"));
		return 0;
	case WM_PAINT:
		{
			HDC 		hDC;
			PAINTSTRUCT ps;
			hDC = BeginPaint(hWnd,&ps);
			int wdh = b32GetWidth(hBmp2);
			int hgt = b32GetHeight(hBmp2);
			b32DrawColor(hBmp1, 128, 255, 255, 255);
			b32SetFont(TEXT("lr o"), FW_MEDIUM, SHIFTJIS_CHARSET, DEFAULT_PITCH | FF_DONTCARE, PROOF_QUALITY);
			b32DrawFont(hBmp1, TEXT("͂["), 80, 0, 0, 255, 255, 255);
			b32Hue(hBmp2, 128, 100, 100, 200, 100);
			b32Draw32(hBmp2, 50, 50, hBmp1, 0, 0, wdh, hgt, 255);
			b32Draw32(hBmp2, 100, 150, hBmp3, 0, 0, 200, 200, 128);
			if(b32GetBPP(hBmp2) == 32){
				BYTE *pData = b32GetBits(hBmp2);
				int x,y;
				for(y=0; y<hgt/10; y++){
					for(x=0; x<wdh; x++){
						*pData = (BYTE) 0x00;	// 
						pData ++;
						*pData = (BYTE) 0xff;	// 
						pData ++;
						*pData = (BYTE) 0x00;	// 
						pData ++;
						*pData = (BYTE) 0x00;	// x
						pData ++;
					}
				}
			}
			b32DrawDC(hDC, 0, 0, hBmp2, 0, 0, wdh, hgt);
			EndPaint(hWnd,&ps);
		}
		return 0;
	case WM_CLOSE:
		b32Delete(hBmp1);
		b32Delete(hBmp2);
		b32Delete(hBmp3);
		DestroyWindow(hWnd);
		PostQuitMessage(0);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}
